This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours

Bug 998503 (vagrant_changes_tracker)

Summary: Vagrant
Product: [Fedora] Fedora Reporter: Jaroslav Reznik <jreznik>
Component: Changes TrackingAssignee: Jaroslav Reznik <jreznik>
Status: CLOSED NEXTRELEASE QA Contact:
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 20CC: admiller, adrahon, aron, bobbypowers, fedora, gdubreui, jchristi, jmatthew, jshubin, mattdm, mike, misc, purpleidea, ricardo.arguello, sagarun, sergio, tadej.j
Target Milestone: ---Keywords: Tracking
Target Release: ---Flags: jshubin: needinfo? (admiller)
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2015-05-14 20:40:13 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On: 905240, 960554, 1020456, 1020457, 1168333    
Bug Blocks:    

Description Jaroslav Reznik 2013-08-19 09:04:00 EDT
This is a tracking bug for Change: Vagrant
For more details, see: http://fedoraproject.org//wiki/Changes/Vagrant

Provide Vagrant http://www.vagrantup.com/ with the KVM plugin.
Comment 1 Alex Drahon 2013-08-27 03:52:24 EDT
I have working packages, but there are still some blocking issues:
 1. Vagrant works (with VirtualBox) but plugin installation/loading doesn't, it may be a compatibility issue with Ruby 2 (vs 1.9), investigating that
 2. Vagrant-kvm isn't seen as a plugin by Vagrant, there are some gems loading path issues.

These issues seem related and should be fixable.
Comment 2 Jaroslav Reznik 2013-08-27 04:47:48 EDT
Alex,
thanks for status. Do bugs for these issues exist? If so, please block this tracker.
Comment 3 Alex Drahon 2013-08-27 07:44:00 EDT
(In reply to Jaroslav Reznik from comment #2)
> Alex,
> thanks for status. Do bugs for these issues exist? If so, please block this
> tracker.

I didn't create bugs yet, I asked other people to help me track down the issues. Should I create bugs for each (suspected) blocking issue?
Comment 4 Jaroslav Reznik 2013-08-27 11:03:32 EDT
(In reply to Alex Drahon from comment #3)
> (In reply to Jaroslav Reznik from comment #2)
> > Alex,
> > thanks for status. Do bugs for these issues exist? If so, please block this
> > tracker.
> 
> I didn't create bugs yet, I asked other people to help me track down the
> issues. Should I create bugs for each (suspected) blocking issue?

It would be easier to track status of the Change but status update is ok for me.
Comment 5 Jaroslav Reznik 2013-10-11 04:44:22 EDT
This message is a reminder that Fedora 20 Accepted Changes 100%
Completed Deadline is on 2013-10-15 [1].

All Accepted Changes has to be code complete and ready to be
validated in the Beta release (optionally by Fedora QA). Required
bug state at this point is ON_QA.

As for several System Wide Changes, Beta Change Deadline is a
point of contingency plan, all incomplete Changes will be 
reported to FESCo for 2013-10-16 meeting. In case of any
questions, don't hesitate to ask Wrangler (jreznik).

[1] https://fedoraproject.org/wiki/Releases/20/Schedule
Comment 6 M. Edward (Ed) Borasky 2013-12-13 12:31:11 EST
Did this make it into F20?
Comment 7 Alex Drahon 2014-01-03 08:58:05 EST
(In reply to M. Edward (Ed) Borasky from comment #6)
> Did this make it into F20?

It's still blocked by a storage pool related bug being worked on upstream (vagrant-kvm).
Comment 8 Michael Scherer 2014-01-12 09:17:43 EST
Could you give the link to the bug, so people who are interested could follow it there directly ?
Comment 9 Alex Drahon 2014-01-12 11:23:56 EST
https://github.com/adrahon/vagrant-kvm/issues/130

Not a lot of details because we did a poor job at going to the root of the issue.
Comment 10 Bobby Powers 2014-02-26 17:35:36 EST
Good news everyone!  It looks like that upstream storage pool issue is fixed: https://github.com/adrahon/vagrant-kvm/issues/130 . At the very least, they closed the bug.  It looks like they reset the permissions on the disk image:
https://github.com/adrahon/vagrant-kvm/pull/152

Can someone who was experiencing this issue confirm its better on Fedora?  It would be great to get vagrant moving again.
Comment 11 purpleidea 2014-03-26 13:33:42 EDT
I've been working quite a lot with vagrant and vagrant-libvirt on Fedora.
My original foray into vagrant is here:

https://ttboj.wordpress.com/2013/12/09/vagrant-on-fedora-with-libvirt/

There are subsequent articles that have more information. Also, there are newer versions of vagrant available which might be better to use.

In any case, I propose this should happen, and in fact, I think vagrant-libvirt is a great candidate. https://github.com/pradels/vagrant-libvirt/

It's particularly nice because you can use it hand-in-hand with the libvirt tools, and if you wanted to use a different provider that libvirt supported, you could do that.

It would be particularly useful to get something like this into fedora, because then I could ensure that associated things that I'd like to distribute (eg: puppet-gluster [1] ) would be "guaranteed" to work with whatever version of Fedora+Vagrant+Vagrant-libvirt was present in that Fedora.

This is a great way to give new/potential/prospective users of a product an easy way to try it out. (Eg: just 'vagrant up' and try out your new GlusterFS cluster.)

Cheers,
James

[1] https://github.com/purpleidea/puppet-gluster
Comment 12 Alex Drahon 2014-04-09 06:58:41 EDT
(In reply to Bobby Powers from comment #10)
> Good news everyone!  It looks like that upstream storage pool issue is
> fixed: https://github.com/adrahon/vagrant-kvm/issues/130 . At the very
> least, they closed the bug.  It looks like they reset the permissions on the
> disk image:
> https://github.com/adrahon/vagrant-kvm/pull/152
> 
> Can someone who was experiencing this issue confirm its better on Fedora? 
> It would be great to get vagrant moving again.

We still are facing issues on Fedora. We pushed an update to the plugin that works on most other distros and we're working on a workaround for Fedora.

In the end we couldn't track the source of the problem, my bet is on sVirt...
Comment 13 James (purpleidea) 2014-05-13 19:35:23 EDT
FYI, you might want to checkout the latest vagrant-libvirt and vagrant 1.5.4

I've written a new article, here:
https://ttboj.wordpress.com/2014/05/13/vagrant-on-fedora-with-libvirt-reprise/

See my last paragraph for some reasoning about how important packaging this is.

Thanks!
Comment 14 Matthew Miller 2014-05-13 19:45:45 EDT
Alex, what do you think about refocusing efforts on the libvirt plugin? Maybe that's the best way to go forward if we're stuck with the kvm one?
Comment 15 Alex Drahon 2014-05-15 05:22:19 EDT
There's been a lot of change both in Vagrant and vagrant-kvm in the last few months that should make packaging easier. Vagrant-kvm (head) works well on Fedora 20 now, and we're near a proper release.

I'm not convinced vagrant-libvirt is easier to package, but I'm biaised of course.
Comment 16 Matthew Miller 2014-05-15 08:54:19 EDT
(In reply to Alex Drahon from comment #15)
> I'm not convinced vagrant-libvirt is easier to package, but I'm biaised of
> course.

I don't really care... I just want: a) some good vagrant option in the distribution, b) particularly, something that's really easy for users, and c) everyone who is interested and working on it to be happy. :)

James makes the point that the libvirt plugin has a technical advantage in that it can talk to multiple machines. Is that compelling enough to make it the preferred approach? (This comes to "b" -- we probably only want to be promoting one solution in the documentation, even if both are available.)
Comment 17 James (purpleidea) 2014-05-15 12:26:24 EDT
(In reply to Alex Drahon from comment #15)

> I'm not convinced vagrant-libvirt is easier to package, but I'm biaised of
> course.

This might be completely true, actually, although I don't see why vagrant-libvirt would necessarily be harder. All I know, is that I'm not a packager :)
In the gluster community, we call it "paintaining" (you know, Package maintaining...)

But I do see a big value of the multi-machine and extra disks features for vagrant-libvirt.
Comment 18 Sergio Monteiro Basto 2014-07-14 18:44:17 EDT
just add me I'd like see vagrant in Fedora.
bug #905240 I don't understand who is unresponsive , but is stalled ...
Comment 19 Matthew Miller 2014-07-14 20:15:33 EDT
(In reply to Sergio Monteiro Basto from comment #18)
> just add me I'd like see vagrant in Fedora.
> bug #905240 I don't understand who is unresponsive , but is stalled ...

I pinged the maintainer of that bug. Note also that Alex Drahon needs a sponsor for the vagrant packages, at least according to the "bugs needing a sponsor" page. If anyone could help with that, it'd speed things up.
Comment 20 James (purpleidea) 2014-07-14 22:08:06 EDT
(In reply to Matthew Miller from comment #19)
> (In reply to Sergio Monteiro Basto from comment #18)
> > just add me I'd like see vagrant in Fedora.
> > bug #905240 I don't understand who is unresponsive , but is stalled ...
> 
> I pinged the maintainer of that bug. Note also that Alex Drahon needs a
> sponsor for the vagrant packages, at least according to the "bugs needing a
> sponsor" page. If anyone could help with that, it'd speed things up.

Any lucky on our vagrant-libvirt RPM hacking btw? I would still like that to succeed. I'm finding new use cases almost weekly.
Comment 21 Adam Miller 2014-07-14 23:13:08 EDT
I'm relatively confident that I have vagrant-libvirt packaged but packaging vagrant itself has provden to be a bit of a pain and I haven't had nearly as much time to work on it as I had hoped. So I'm not 100% sure that vagrant-libvirt works since I don't have a properly packaged vagrant setup. If you install from upstream it's a bundled mess with hardcoded pathing. I honeslty just don't know my way around vagrant or it's code base well enough.

http://maxamillion.fedorapeople.org/rubygem-vagrant-libvirt.spec
http://maxamillion.fedorapeople.org/rubygem-vagrant-libvirt-0.0.16-1.fc20.src.rpm

http://copr.fedoraproject.org/coprs/maxamillion/vagrant-libvirt/
Comment 22 Sergio Monteiro Basto 2014-07-15 06:14:11 EDT
(In reply to Matthew Miller from comment #19)
> I pinged the maintainer of that bug. Note also that Alex Drahon needs a
> sponsor for the vagrant packages, at least according to the "bugs needing a
> sponsor" page. If anyone could help with that, it'd speed things up.

I don't feel comfortable in sponsor anyone , since I'm overloaded, also ruby is not my garden, just want see what vagrant could do for me. In my workplace, my colleagues are very enthusiastic and seems that manage Vboxs .
Comment 23 Gilles Dubreuil 2014-08-05 03:29:21 EDT
Hi,

Fedora 20 vagrant is working with Fedora 20, RHEL6 and 7 guests.

Using vagrant 1.6.3 along libvirt plugin. When installing the plugin, make sure to specify version with --plugin-version=0.0.19 (or newer when available).

Please see details here [1]

Regarding Fedora 20 network issue: 
I've submitted Pull Request 4297 to vagrant repo [2]
I hope it works for you too, please confirm.

Using Fedora 20 cloud image [3] prepared for vagrant-libvirt [4]. 

[1] http://gil-dub.blogspot.com.au/
[2] https://github.com/mitchellh/vagrant/pull/4297
[3] http://download.fedoraproject.org/pub/fedora/linux/updates/20/Images/x86_64/Fedora-x86_64-20-20140407-sda.qcow2
[4] http://gil-dub.blogspot.com.au/2014/08/create-vagrant-image-box-for-libvirtkvm.html
Comment 24 Alex Drahon 2014-08-05 11:20:04 EDT
Hi all,

I now think that it's not a good idea to package Vagrant for Fedora. The upstream package works, and is designed as a self-contained environment, including rubygems management, so it's a bit hacky to make it work in the standard Fedora environment. 

vagrant-kvm (and vagrant-libvirt of course) mostly work these days, but the hard part (hard to automate) is the configuration of polkit and firewalld (see https://github.com/adrahon/vagrant-kvm/wiki/Install_on_Fedora).

I don't think we can reach a fully automated experience from `yum install` to `vagrant up`, so I don't really see the value.

I'd like to retract my review request, I'll happily help any one else wanting to make it happen.

Alex
Comment 25 James (purpleidea) 2014-08-05 11:48:04 EDT
(In reply to Alex Drahon from comment #24)
> Hi all,
> 
> I now think that it's not a good idea to package Vagrant for Fedora. The
> upstream package works, and is designed as a self-contained environment,
> including rubygems management, so it's a bit hacky to make it work in the
> standard Fedora environment. 
> 
> vagrant-kvm (and vagrant-libvirt of course) mostly work these days, but the
> hard part (hard to automate) is the configuration of polkit and firewalld
> (see https://github.com/adrahon/vagrant-kvm/wiki/Install_on_Fedora).
> 
> I don't think we can reach a fully automated experience from `yum install`
> to `vagrant up`, so I don't really see the value.
> 
> I'd like to retract my review request, I'll happily help any one else
> wanting to make it happen.
> 
> Alex

It would be great if there was a way to make a vagrant-libvirt RPM that could be just as easily installed as well... Maxamillion started looking at this, but it was a bit tricky to get vagrant to see the plugin... Any help with this would be appreciated. Making a one step solution to install vagrant-libvirt would be very useful.

As for whether vagrant should be packaged in Fedora, I do still see value in this, but I'm okay using the upstream RPM's until that time.
Comment 26 Alex Drahon 2014-08-05 12:16:37 EDT
(In reply to James from comment #25)
> (In reply to Alex Drahon from comment #24)
> > Hi all,
> > 
> > I now think that it's not a good idea to package Vagrant for Fedora. The
> > upstream package works, and is designed as a self-contained environment,
> > including rubygems management, so it's a bit hacky to make it work in the
> > standard Fedora environment. 
> > 
> > vagrant-kvm (and vagrant-libvirt of course) mostly work these days, but the
> > hard part (hard to automate) is the configuration of polkit and firewalld
> > (see https://github.com/adrahon/vagrant-kvm/wiki/Install_on_Fedora).
> > 
> > I don't think we can reach a fully automated experience from `yum install`
> > to `vagrant up`, so I don't really see the value.
> > 
> > I'd like to retract my review request, I'll happily help any one else
> > wanting to make it happen.
> > 
> > Alex
> 
> It would be great if there was a way to make a vagrant-libvirt RPM that
> could be just as easily installed as well... Maxamillion started looking at
> this, but it was a bit tricky to get vagrant to see the plugin... Any help
> with this would be appreciated. Making a one step solution to install
> vagrant-libvirt would be very useful.
> 
If you look in my srpm http://srpms.adrahon.org/vagrant-1.3.3-1.1.fc20.src.rpm there are patches to make vagrant look into the system-wide rubygems and register plugins. Vagrant plugins are just rubygems, but they are maintained in the user's ~/.vagrant.d directory.

> As for whether vagrant should be packaged in Fedora, I do still see value in
> this, but I'm okay using the upstream RPM's until that time.
Comment 27 Adam Miller 2014-08-05 12:37:09 EDT
After that first run at it, I really haven't had time to work on it. All progress made thus far can be found here: 

http://copr.fedoraproject.org/coprs/maxamillion/vagrant-libvirt/

It's admittedly a bit of a mess and it doesn't quite work yet, grain of salt, there be dragons, etc.
Comment 28 Gilles Dubreuil 2014-08-05 22:21:09 EDT
For info, Fedora 20 network issue has been merged and is likely to be available in next vagrant release:
https://github.com/mitchellh/vagrant/commit/bd4d4284c473860b800906e4db889b5a04552d70

> As for whether vagrant should be packaged in Fedora, I do still see value in
> this, but I'm okay using the upstream RPM's until that time.

Fedora becoming one of the main Linux developer platform, having Vagrant available is really a must have.
Comment 29 James (purpleidea) 2014-08-05 22:30:26 EDT
(In reply to Alex Drahon from comment #26)
> If you look in my srpm
> http://srpms.adrahon.org/vagrant-1.3.3-1.1.fc20.src.rpm there are patches to
> make vagrant look into the system-wide rubygems and register plugins.
> Vagrant plugins are just rubygems, but they are maintained in the user's
> ~/.vagrant.d directory.

This is awesome Alex!! Thanks.

@Adam, I think this contains the patches we were trying to write! Any chance you can look at this again?

RE: Gilles

> Fedora becoming one of the main Linux developer platform, having Vagrant available is really a must have.

I agree... I guess we're fashionably late to the party, but it would still be nice to attend. I hear there are free $BEVERAGES ;)
Comment 31 Gilles Dubreuil 2014-09-18 23:11:30 EDT
Latest vagrant build works out of the box!
Comment 32 Gilles Dubreuil 2014-09-18 23:14:01 EDT
(In reply to Gilles Dubreuil from comment #31)
> Latest vagrant build works out of the box!

Vagrant 1.6.5
Comment 33 Tadej Jane┼ż 2014-09-19 05:09:06 EDT
Hi, Gilles!

(In reply to Gilles Dubreuil from comment #32)
> > Latest vagrant build works out of the box!
> 
> Vagrant 1.6.5

Thanks for the update. Care to elaborate a bit more on what has changed?
Comment 34 Sergio Monteiro Basto 2014-09-19 06:31:24 EDT
(In reply to Gilles Dubreuil from comment #31)
> Latest vagrant build works out of the box!

could you provides the .spec ? 
and if possible and executable diff from previous .spec ? 
also point to one src.rpm will help 

Thanks,
Comment 35 Gilles Dubreuil 2014-09-19 07:31:57 EDT
yum -y install libvirt-devel libxslt-devel libxml2-devel
yum -y install https://dl.bintray.com/mitchellh/vagrant/vagrant_1.6.5_x86_64.rpm

Note: The rpm from https://www.vagrantup.com/downloads.html is the same.

Then, to be able to use libvirt(kvm):
vagrant plugin install vagrant-libvirt --plugin-version=0.0.20

More details are in the links from Comment#30

Trying to obtain the spec file.
Comment 36 Sergio Monteiro Basto 2014-09-19 07:59:53 EDT
from bug #1113808

Just opened: https://github.com/mitchellh/vagrant/issues/4117
(Where are the .spec files?)
Comment 37 Adam Miller 2014-09-19 10:59:55 EDT
I was ping'd "off-list" to provide some feedback here, so here goes. :)

This is a fundamental problem with Vagrant, the upstream project doesn't care about the ability to redistribute outside of their binary releases[0]. We can either work our way through their fpm automation process as upstream suggests and create a spec file to the best of our ability that complies with Fedora Guidelines or we just don't and instead make a document somewhere for users on how to update. I really don't have the spare cycles to do that work right now, but it would certainly be nice for the Fedora userbase if someone did. I can try to free up some amount of time in the not too distant future to work on it but if someone has the cycles now that'd be great.

Something to note, since upstream doesn't care about downstream distros it might be good to put together documentation on the process that is used to deduce what all needs to be put into the spec file that does comply with Fedora Guidelines. Both for the sake of posterity as well as a reference for other rpm based distros who might want to follow suit. If I end up being the first one with free time to do this, I will create a doc and will place its URL in this BZ for others to follow along with the fun(hopefully progress). However if I'm not, I would like to request who ever does pick this up does the same.

Alright ... I'm done rambling.

Thanks everyone,
-AdamM

[0] - https://github.com/mitchellh/vagrant/issues/4117
Comment 38 James (purpleidea) 2014-09-19 11:34:56 EDT
There is currently an effort underway to package Vagrant+Vagrant-Libvirt in Fedora... I will post any news as soon as it's ready. Thanks again to AdamM for starting the effort...
Comment 39 Adam Miller 2014-09-19 11:43:34 EDT
James,
    That's wonderful news! To whom ever is working on that along with you and you, you are all collectively rockstars and I think I speak for everyone when I say thank you for your efforts. This will certainly be a welcomed feature among the Fedora users. :)

-AdamM
Comment 40 M. Edward (Ed) Borasky 2014-09-24 04:32:50 EDT
I see vagrant is not in F21 alpha. Does that mean we need to wait for F22 or is there still a chance it makes it into the repos? I have run the RPMs from the Vagrant project on F21 pre-alpha and the easy stuff - default ubuntu guests with VirtualBox - works just like it did on F20. That's about all I need from vagrant - I don't use it except for when somebody hands me a vagrantfile and says, "Use this". ;-)
Comment 41 James (purpleidea) 2014-09-24 14:36:29 EDT
(In reply to M. Edward (Ed) Borasky from comment #40)
> I see vagrant is not in F21 alpha. Does that mean we need to wait for F22 or
> is there still a chance it makes it into the repos? I have run the RPMs from
> the Vagrant project on F21 pre-alpha and the easy stuff - default ubuntu
> guests with VirtualBox - works just like it did on F20. That's about all I
> need from vagrant - I don't use it except for when somebody hands me a
> vagrantfile and says, "Use this". ;-)

As in the previous comment, packaging is underway... When it works, we'll submit it for Fedora... Whether that makes the deadline for core is unclear, but it will at least be available in a COPR or similar.
Comment 42 Karim Boumedhel 2015-01-02 07:51:20 EST
for what it s worth, i was able to use vagrant along with vagrant-libvirt on f21 using the following repo
baseurl=https://copr-be.cloud.fedoraproject.org/results/jstribny/vagrant-f21/fedora-21-x86_64
might be worth putting in the documentation
Comment 43 Gilles Dubreuil 2015-01-16 00:43:01 EST
Thanks Karim, very helpful.

Effectively, on Fedora 21, I tried all the vagrant builds from https://dl.bintray.com/mitchellh/vagrant/ starting from 1.6.5 up to the latest and none is working.
Comment 44 Gilles Dubreuil 2015-02-09 20:13:10 EST
The package is available according to BZ#1020456

The only thing is I couldn't find it yet in fedora 21 updates but it was available in Development/Rawhide/22 and it works without any trouble. Thanks!
Comment 46 Sergio Monteiro Basto 2015-05-14 20:38:13 EDT
Hello, 
vangrant, vagrant-libvirt and vagrant-lxc [1] are available, may we close this tracker ? 

[1]
http://koji.fedoraproject.org/koji/packageinfo?packageID=19808 
http://koji.fedoraproject.org/koji/packageinfo?packageID=19861
http://koji.fedoraproject.org/koji/packageinfo?packageID=19886
Comment 47 James (purpleidea) 2015-05-14 20:39:45 EDT
(In reply to Sergio Monteiro Basto from comment #46)
> Hello, 
> vangrant, vagrant-libvirt and vagrant-lxc [1] are available, may we close
> this tracker ? 
> 
> [1]
> http://koji.fedoraproject.org/koji/packageinfo?packageID=19808 
> http://koji.fedoraproject.org/koji/packageinfo?packageID=19861
> http://koji.fedoraproject.org/koji/packageinfo?packageID=19886

I guess so, however there is still at least one serious bug before it's really usable for me:

https://bugzilla.redhat.com/show_bug.cgi?id=1221006